searchData={"items":[{"type":"module","title":"PrusaLink","doc":"PrusaLink module to interface with a Prusa 3D printer via local PrusaLink.\nTo start setup a printer by calling `PrusaLink.printer(host_or_ip, pw)`.\nThe result is a printer struct you can pass to any other method to interact with that printer.","ref":"PrusaLink.html"},{"type":"function","title":"PrusaLink.files/2","doc":"","ref":"PrusaLink.html#files/2"},{"type":"function","title":"PrusaLink.files/3","doc":"","ref":"PrusaLink.html#files/3"},{"type":"function","title":"PrusaLink.job/1","doc":"","ref":"PrusaLink.html#job/1"},{"type":"function","title":"PrusaLink.job_pause/2","doc":"","ref":"PrusaLink.html#job_pause/2"},{"type":"function","title":"PrusaLink.job_resume/2","doc":"","ref":"PrusaLink.html#job_resume/2"},{"type":"function","title":"PrusaLink.job_stop/2","doc":"","ref":"PrusaLink.html#job_stop/2"},{"type":"function","title":"PrusaLink.print/3","doc":"","ref":"PrusaLink.html#print/3"},{"type":"function","title":"PrusaLink.printer/2","doc":"","ref":"PrusaLink.html#printer/2"},{"type":"function","title":"PrusaLink.specs/1","doc":"","ref":"PrusaLink.html#specs/1"},{"type":"function","title":"PrusaLink.status/1","doc":"","ref":"PrusaLink.html#status/1"},{"type":"function","title":"PrusaLink.storage/1","doc":"","ref":"PrusaLink.html#storage/1"},{"type":"function","title":"PrusaLink.upload/2","doc":"Upload a file to the given printer.\n\nAutomatically extracts the target filename on the printer from the given path.\nUploads to usb storage.\nSee also: `PrusaLink.Api.upload/4`","ref":"PrusaLink.html#upload/2"},{"type":"function","title":"PrusaLink.upload/3","doc":"","ref":"PrusaLink.html#upload/3"},{"type":"function","title":"PrusaLink.upload/4","doc":"","ref":"PrusaLink.html#upload/4"},{"type":"module","title":"PrusaLink.Api","doc":"Endpoint implementation according to the openapi spec from Prusa:\nhttps://github.com/prusa3d/Prusa-Link-Web/blob/master/spec/openapi.yaml","ref":"PrusaLink.Api.html"},{"type":"function","title":"PrusaLink.Api.api_version/1","doc":"","ref":"PrusaLink.Api.html#api_version/1"},{"type":"function","title":"PrusaLink.Api.files/3","doc":"Retuns a file listing for the given storage and path.\nTo find out which storage options are connected to the printer see `PrusaLink.Api.storage/1`","ref":"PrusaLink.Api.html#files/3"},{"type":"function","title":"PrusaLink.Api.info/2","doc":"","ref":"PrusaLink.Api.html#info/2"},{"type":"function","title":"PrusaLink.Api.job/1","doc":"Returns information about the current printing job if one is running.\nOtherwise it returns an emtpy list.","ref":"PrusaLink.Api.html#job/1"},{"type":"function","title":"PrusaLink.Api.job_pause/2","doc":"Pauses the execution of a currently running job.\nCan be resumed later.","ref":"PrusaLink.Api.html#job_pause/2"},{"type":"function","title":"PrusaLink.Api.job_resume/2","doc":"Resumes a job that was paused before.","ref":"PrusaLink.Api.html#job_resume/2"},{"type":"function","title":"PrusaLink.Api.job_stop/2","doc":"Stops a currently running job.\nThe job can not be resumed.","ref":"PrusaLink.Api.html#job_stop/2"},{"type":"function","title":"PrusaLink.Api.print/3","doc":"Starts a print job with the given file.","ref":"PrusaLink.Api.html#print/3"},{"type":"function","title":"Examples - PrusaLink.Api.print/3","doc":"iex> PrusaLink.Api.print(printer, \"usb\", \"/model.bgcode\")\n    {:ok, []}","ref":"PrusaLink.Api.html#print/3-examples"},{"type":"function","title":"PrusaLink.Api.status/1","doc":"Retrieves current status from the printer.","ref":"PrusaLink.Api.html#status/1"},{"type":"function","title":"Examples - PrusaLink.Api.status/1","doc":"iex> PrusaLink.status(printer)\n    {:ok, %{\n      job: %{\n        id: 297,\n        progress: 91.00,\n        time_remaining: 600,\n        time_printing: 7718\n      },\n      storage: %{\n        path: \"/usb/\",\n        name: \"usb\",\n        read_only: false\n      },\n      printer: %{\n        state: \"PRINTING\",\n        temp_bed: 60.0,\n        target_bed: 60.0,\n        temp_nozzle: 209.9,\n        target_nozzle: 210.0,\n        axis_z: 2.4,\n        flow: 100,\n        speed: 100,\n        fan_hotend: 3099,\n        fan_print: 5964\n      }\n    }}","ref":"PrusaLink.Api.html#status/1-examples"},{"type":"function","title":"PrusaLink.Api.storage/1","doc":"Returns storage information.","ref":"PrusaLink.Api.html#storage/1"},{"type":"function","title":"PrusaLink.Api.upload/4","doc":"Upload a file to the given printer storage.\nThe given path should include the target filename of the file on the printer and not just the folder.\n\nNOTE:\nDoes not override existing file and does not start printing automatically after upload.","ref":"PrusaLink.Api.html#upload/4"},{"type":"function","title":"Examples - PrusaLink.Api.upload/4","doc":"iex> PrusaLink.Api.upload(printer, \"usb\", \"/model.bgcode\", file_content)\n    {:ok, []}","ref":"PrusaLink.Api.html#upload/4-examples"},{"type":"module","title":"PrusaLink.Printer","doc":"Representation of a Prusa 3D printer and how to connect to it.","ref":"PrusaLink.Printer.html"},{"type":"function","title":"PrusaLink.Printer.new/2","doc":"Create a new printer representation.\nIt tries to connect to two endpoints (version & info) to retrieve meta information.\n\nReturns a %PrusaLink.Printer{} struct including the information to connect to the printer as well as some meta information.\nIf the printer can not be reached it returns a tuple with {:unreachable, %Printer{}}.\nThe printer struct can still be used to connect to the printer later assuming the giving information is correct.","ref":"PrusaLink.Printer.html#new/2"},{"type":"function","title":"PrusaLink.Printer.specs/1","doc":"Retuns the meta information retrieved from the printer when connecting to it the first time.","ref":"PrusaLink.Printer.html#specs/1"},{"type":"function","title":"Examples - PrusaLink.Printer.specs/1","doc":"iex> PrusaLink.Printer.specs(mk4)\n    %{\n      name: \"prusa-mk4\",\n      serial: \"1234567890\",\n      api_version: 1,\n      capabilities: %{\"upload-by-put\" => true},\n      nozzle: 0.4,\n      mmu: false\n    }","ref":"PrusaLink.Printer.html#specs/1-examples"},{"type":"extras","title":"PrusaLink","doc":"# PrusaLink\n\nA wrapper around the local PrusaLink API of a supported Prusa 3D printer (MK4/S, MK3.9/S, MK3.5/S, XL, MINI / MINI +, SL1, SL1S SPEED).\nFor further instructions how to setup PrusaLink (and obtain IP and password) have a look at the official [Guide](https://help.prusa3d.com/guide/wi-fi-and-prusalink-setup-mk4-mk3-9-mk3-5-xl-mini_413293) from Prusa.\n\nCurrently supports:\n- status info\n- job info\n- start print job\n- stop, pause, continue a job\n- retrieve storage info\n- file and directory listing\n- file upload (since v0.1.1)","ref":"readme.html"},{"type":"extras","title":"Usage - PrusaLink","doc":"```elixir\n{:ok, mk4} = PrusaLink.printer(\"192.168.10.10\", \"your_password\")\n\nPrusaLink.specs(mk4)\n> %{\n    name: \"prusa-mk4\",\n    serial: \"10000-1111444433332222\",\n    api_version: 1,\n    capabilities: %{\"upload-by-put\" => true},\n    mmu: false,\n    nozzle: 0.4\n  }\n\nPrusaLink.status(mk4)\n> {:ok,\n    %{\n      \"printer\" => %{\n        \"axis_x\" => 241.0,\n        \"axis_y\" => 170.0,\n        \"axis_z\" => 61.5,\n        \"fan_hotend\" => 0,\n        \"fan_print\" => 0,\n        \"flow\" => 100,\n        \"speed\" => 100,\n        \"state\" => \"FINISHED\",\n        \"target_bed\" => 0.0,\n        \"target_nozzle\" => 0.0,\n        \"temp_bed\" => 23.9,\n        \"temp_nozzle\" => 25.0\n      },\n      \"storage\" => %{\"name\" => \"usb\", \"path\" => \"/usb/\", \"read_only\" => false}\n  }}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Installation - PrusaLink","doc":"The package can be installed by adding `prusa_link` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:prusa_link, \"~> 0.1.1\"}\n  ]\nend\n```\n\nDocumentation can be found at  .","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}